#include <stdio.h>
#include <sys/types.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <stdlib.h>
#define BUFSZ 4096

int main(void)
{
	int readsemid, writesemid;
	union semun {
		int val;
		struct semid_ds *buf;
		unsigned short *array;
		struct seminfo *__buf;
	} semval;

	if ((readsemid = semget(999, 1, 0666 | IPC_CREAT)) < 0) {
		perror("semget readsem");
		exit(-1);
	}
	semval.val = 0;
	if (semctl(readsemid, 0, SETVAL, semval) != 0) {
		perror("semctl readsem setval");
		exit(-1);
	}
	printf("initial readsem val: %d\n", semctl(readsemid, 0, GETVAL));

	if ((writesemid = semget(1099, 1, 0666 | IPC_CREAT)) < 0) {
		perror("semget writesem");
		exit(-1);
	}
	semval.val = 1;
	if (semctl(writesemid, 0, SETVAL, semval) != 0) {
		perror("semctl writesem setval");
		exit(-1);
	}
	printf("initial writesem val: %d\n", semctl(writesemid, 0, GETVAL));

	if (shmget(888, BUFSZ, 0666 | IPC_CREAT) < 0) {
		perror("shmget");
		exit(-1);
	}
	return 0;
}
